$regfile = "m8def.dat"
$crystal = 8000000
'Porty
Config Pinb.0 = Output                                      'Anoda 1
Config Pinb.1 = Output                                      'Anoda 3
Config Pinb.2 = Output                                      'Anoda 4
Config Pinb.3 = Output                                      'Anoda 2
Config Pinb.4 = Output                                      'Anody LEDw
Config Pinb.5 = Input                                       'Przycisk OK
Config Pinb.7 = Input                                       'Nieuywany
Config Pinc.0 = Output                                      'Przekanik 4
Config Pinc.1 = Output                                      'Przekanik 3
Config Pinc.2 = Output                                      'Przekanik 2
Config Pinc.3 = Output                                      'Przekanik 1
Config Pinc.4 = Input                                       'Przycisk +
Config Pinc.5 = Input                                       'Przycisk -
Config Portd = Output                                       'Katody
Config 1wire = Pinb.7                                       'Czujnik temperatury

Config Watchdog = 512
Config Timer0 = Timer , Prescale = 64
Timer0 = 6
On Timer0 Czas
Enable Interrupts

Dim Nr As Byte
Dim A As Byte
Dim B As Byte
Dim C As Byte
Dim D As Byte
Dim Msb As Byte
Dim Lsb As Byte
Dim Tryb As Byte
Dim Pm As Integer
Dim Wynik_int As Byte
Dim Wynik_frac As Byte
Dim Zmierz As Bit
Dim Znak As Bit
Dim Imp As Bit
Dim Histereza As Byte
Dim Al1 As Bit
Dim Al2 As Bit
Dim Al3 As Bit
Dim Al4 As Bit
Dim Oczekiwanie As Word
Dim Temp As Integer
Dim Norma1 As Integer
Dim Norma2 As Integer
Dim Norma3 As Integer
Dim Norma4 As Integer
Dim Temp_s As Single
Dim Ds1(8) As Byte
Dim Ds2(8) As Byte
Dim Ds3(8) As Byte
Dim Ds4(8) As Byte
Dim Norma1e As Eram Integer
Dim Norma2e As Eram Integer
Dim Norma3e As Eram Integer
Dim Norma4e As Eram Integer
Dim Histe As Eram Byte

Declare Sub Ods4
Declare Sub Ods5
Declare Sub Ods6
Declare Sub Ods7
Declare Sub Ods8

Rel4 Alias Portc.3
Rel3 Alias Portc.2
Rel2 Alias Portc.1
Rel1 Alias Portc.0
S1 Alias Pinb.5
S2 Alias Pinc.4
S3 Alias Pinc.5

'Tryb 0 - temperatura na 1 czujniku
'Tryb 1 - temperatura na 2 czujniku
'Tryb 2 - temperatura na 3 czujniku
'Tryb 3 - temperatura na 4 czujniku
'Tryb 4 - ustawianie zadanej temperatury 1
'Tryb 5 - ustawianie zadanej temperatury 2
'Tryb 6 - ustawianie zadanej temperatury 3
'Tryb 7 - ustawianie zadanej temperatury 4
'Tryb 8 - ustawianie histerezy

Set Portb.5
Set Portc.4
Set Portc.5
Set Portb.7

Norma1 = Norma1e
Norma2 = Norma2e
Norma3 = Norma3e
Norma4 = Norma4e
Histereza = Histe

A = 10
B = 10
C = 10
D = 10
'Zapisywanie numerw czujnikw

Ds1(1) = 1wsearchfirst()
Ds2(1) = 1wsearchnext()
Ds3(1) = 1wsearchnext()
Ds4(1) = 1wsearchnext()
1wreset
1wwrite &HCC
1wwrite &H44

Enable Timer0
Start Watchdog
Reset Watchdog

Do
If Zmierz = 1 Then
   Reset Zmierz
   Disable Interrupts
   Portd = 0
   'Odczyt biecej temperatury
   1wreset
   1wwrite &H55
   If Tryb = 0 Then
      1wwrite Ds1(1) , 8
   Elseif Tryb = 1 Then
      1wwrite Ds2(1) , 8
   Elseif Tryb = 2 Then
      1wwrite Ds3(1) , 8
   Elseif Tryb = 3 Then
      1wwrite Ds4(1) , 8
   End If
   1wwrite &HBE
   Lsb = 1wread():
   Msb = 1wread():
   1wreset
   'Wszystkie czujniki mierz od nowa
   1wreset
   1wwrite &HCC
   1wwrite &H44
   'Obrbka odczytanej wartoci i wywietlenie
   Temp = Msb * 256
   Temp = Temp + Lsb
   If Msb.7 = 0 Then
      Temp_s = Temp / 16
      Temp = Int(temp_s)
      Wynik_int = Temp
      Reset Znak
   Else
     Temp = Not Temp
     Temp = Temp + 1
     Temp_s = Temp / 16
     Temp = Int(temp_s)
     Wynik_int = Temp
     Temp = Temp * -1
     Set Znak
   End If
   B = Wynik_int Mod 100
   A = Wynik_int - B
   A = A / 100

   Temp_s = Frac(temp_s)
   Temp_s = Temp_s * 10
   Wynik_frac = Round(temp_s)
   D = Wynik_frac
   B = Makebcd(b)
   C = B And &B00001111
   Shift B , Right , 4
   If A = 0 Then
      A = 10
      If B = 0 Then
         If Znak = 0 Then
            B = 10
         Else
            B = 11
         End If
      Else
         If Znak = 1 Then
            A = 11
         End If
      End If
   End If
   'Alarmy
   Pm = Temp - Histereza
   If Tryb = 0 Then
      If Al1 = 0 Then
         If Norma1 > Temp Then
            Set Rel1
            Set Al1
         End If
      Else
         If Pm => Norma1 Then
            Reset Rel1
            Reset Al1
         End If
      End If
   Elseif Tryb = 1 Then
      If Al2 = 0 Then
         If Norma2 > Temp Then
            Set Rel2
            Set Al2
         End If
      Else
         If Pm => Norma2 Then
            Reset Rel2
            Reset Al2
         End If
      End If
   Elseif Tryb = 2 Then
      If Al3 = 0 Then
         If Norma3 > Temp Then
            Set Rel3
            Set Al3
         End If
      Else
         If Pm => Norma3 Then
            Reset Rel3
            Reset Al3
         End If
      End If
   Elseif Tryb = 3 Then
      If Al4 = 0 Then
         If Norma4 > Temp Then
            Set Rel4
            Set Al4
         End If
      Else
         If Pm => Norma4 Then
            Reset Rel4
            Reset Al4
         End If
      End If
   End If
   Enable Interrupts
End If
'Obsuga przyciskw
Debounce S1 , 0 , P1 , Sub
Debounce S2 , 0 , P2 , Sub
Debounce S3 , 0 , P3 , Sub
Loop
End

P1:
If Tryb < 4 Then
   Reset Al1
   Reset Al2
   Reset Al3
   Reset Al3
   Reset Rel1
   Reset Rel2
   Reset Rel3
   Reset Rel4
   Tryb = 4
   Call Ods4
Elseif Tryb = 4 Then
   Norma1e = Norma1
   Bitwait Eecr.1 , Reset
   Tryb = 5
   Call Ods5
Elseif Tryb = 5 Then
   Norma2e = Norma2
   Bitwait Eecr.1 , Reset
   Tryb = 6
   Call Ods6
Elseif Tryb = 6 Then
   Norma3e = Norma3
   Bitwait Eecr.1 , Reset
   Tryb = 7
   Call Ods7
Elseif Tryb = 7 Then
   Norma4e = Norma4
   Bitwait Eecr.1 , Reset
   Tryb = 8
   Call Ods8
Elseif Tryb = 8 Then
   Histe = Histereza
   Bitwait Eecr.1 , Reset
   Tryb = 0
   A = 11
   B = 11
   C = 11
   D = 11
End If
Oczekiwanie = 0
Set Imp
Return

P2:
If Tryb = 4 Then
   Incr Norma1
   If Norma1 = 121 Then
      Norma1 = -50
   End If
   Call Ods4
Elseif Tryb = 5 Then
   Incr Norma2
   If Norma2 = 121 Then
      Norma2 = -50
   End If
   Call Ods5
Elseif Tryb = 6 Then
   Incr Norma3
   If Norma3 = 121 Then
      Norma3 = -50
   End If
   Call Ods6
Elseif Tryb = 7 Then
   Incr Norma4
   If Norma4 = 121 Then
      Norma4 = -50
   End If
   Call Ods7
Elseif Tryb = 8 Then
   Incr Histereza
   If Histereza = 31 Then
      Histereza = 0
   End If
   Call Ods8
End If
Return

P3:
If Tryb = 4 Then
   If Norma1 > -50 Then
      Decr Norma1
   Else
      Norma1 = 120
   End If
   Call Ods4
Elseif Tryb = 5 Then
   If Norma2 > -50 Then
      Decr Norma2
   Else
      Norma2 = 120
   End If
   Call Ods5
Elseif Tryb = 6 Then
   If Norma3 > -50 Then
      Decr Norma3
   Else
      Norma3 = 120
   End If
   Call Ods6
Elseif Tryb = 7 Then
   If Norma4 > -50 Then
      Decr Norma4
   Else
      Norma4 = 0
   End If
   Call Ods7
Elseif Tryb = 8 Then
   If Histereza > 0 Then
      Decr Histereza
   Else
      Histereza = 30
   End If
   Call Ods8
End If
Return

Czas:
Timer0 = 6
Reset Watchdog
'Multipleksowanie wywietlaczy
Reset Portb.0
Reset Portb.1
Reset Portb.2
Reset Portb.3
Reset Portb.4
Incr Nr
If Nr = 5 Then
   Nr = 0
End If
If Nr = 0 Then
   Set Portb.0
   Portd = Lookup(a , Kody)
Elseif Nr = 1 Then
   Set Portb.1
   Portd = Lookup(c , Kody)
   If Tryb < 4 Then
      Set Portd.7
   End If
Elseif Nr = 2 Then
   Set Portb.2
   Portd = Lookup(d , Kody)
Elseif Nr = 3 Then
   Set Portb.3
   Portd = Lookup(b , Kody)
Elseif Nr = 4 Then
   Set Portb.4
   If Tryb = 0 Then
      Portd = 8
   Elseif Tryb = 1 Then
      Portd = 16
   Elseif Tryb = 2 Then
      Portd = 32
   Elseif Tryb = 3 Then
      Portd = 64
   Elseif Tryb = 4 Then
      If Imp = 1 Then
         Portd = 8
      Else
         Portd = 0
      End If
   Elseif Tryb = 5 Then
      If Imp = 1 Then
         Portd = 16
      Else
         Portd = 0
      End If
   Elseif Tryb = 6 Then
      If Imp = 1 Then
         Portd = 32
      Else
         Portd = 0
      End If
   Elseif Tryb = 7 Then
      If Imp = 1 Then
         Portd = 64
      Else
         Portd = 0
      End If
   Elseif Tryb = 8 Then
      Portd = 0
   End If
End If
'Przeczanie wywietlanych temperatur
Incr Oczekiwanie
If Tryb < 4 Then
   If Oczekiwanie = 1500 Then
      Oczekiwanie = 0
      Incr Tryb
      Set Zmierz
      If Tryb = 4 Then
         Tryb = 0
      End If
   End If
Else
  If Oczekiwanie = 200 Then
     Toggle Imp
     Oczekiwanie = 0
  End If
End If
Return

Sub Ods4:
A = Abs(norma1)
B = A Mod 100
A = A - B
A = A / 100
B = Makebcd(b)
C = B And &B00001111
Shift B , Right , 4
D = 12
If A = 0 Then
   A = 10
   If B = 0 Then
      If Norma1 < 0 Then
         B = 11
      Else
         B = 10
      End If
   Else
      If Norma1 < 0 Then
         A = 11
      End If
   End If
End If
End Sub

Sub Ods5:
A = Abs(norma2)
B = A Mod 100
A = A - B
A = A / 100
B = Makebcd(b)
C = B And &B00001111
Shift B , Right , 4
D = 12
If A = 0 Then
   A = 10
   If B = 0 Then
      If Norma2 < 0 Then
         B = 11
      Else
         B = 10
      End If
   Else
      If Norma2 < 0 Then
         A = 11
      End If
   End If
End If
End Sub

Sub Ods6:
A = Abs(norma3)
B = A Mod 100
A = A - B
A = A / 100
B = Makebcd(b)
C = B And &B00001111
Shift B , Right , 4
D = 12
If A = 0 Then
   A = 10
   If B = 0 Then
      If Norma3 < 0 Then
         B = 11
      Else
         B = 10
      End If
   Else
      If Norma3 < 0 Then
         A = 11
      End If
   End If
End If
End Sub

Sub Ods7:
A = Abs(norma4)
B = A Mod 100
A = A - B
A = A / 100
B = Makebcd(b)
C = B And &B00001111
Shift B , Right , 4
D = 12
If A = 0 Then
   A = 10
   If B = 0 Then
      If Norma4 < 0 Then
         B = 11
      Else
         B = 10
      End If
   Else
      If Norma4 < 0 Then
         A = 11
      End If
   End If
End If
End Sub

Sub Ods8:
A = 13
D = 12
B = Makebcd(histereza)
C = B And &B00001111
Shift B , Right , 4
If B = 0 Then
   B = 10
End If
End Sub


Kody:
Data &B01110111 , &B01000001 , &B00111011 , &B01101011 , &B01001101,       '0, 1, 2, 3, 4
Data &B01101110 , &B01111110 , &B01000011 , &B01111111 , &B01101111,       '5, 6, 7, 8, 9
Data &B00000000 , &B00001000 , &B00001111 , &B01011101 ,    '[puste], -, [znak stopnia], H